function signal = myidwt(coefs,L,wav_name)

% MYIDWT performs the wavelet reconstruction of the signal from its wavelet coefficients
%
% signal = MYIDWT(coefs, L, wav_name)
%
% Input parameters:
% ~~~~~~~~~~~~~~~~~
% coefs...........wavelet coefficients of the signal. Variable type 'cell'.
%                 For appropriate structure see output parameter of 'mydwt.m'.
% L...............vector containing the number of wavelet coefficients in individual levels;
%                 see 'wavedec.m' from Matlab's Wavelet Toolbox
% wav_name........name of the reconstruction wavelet; string, for example 'db3'
%
% Output parameters:
% ~~~~~~~~~~~~~~~~~~
% signal..........reconstructed signal

% (c)2003 Pavel Rajmic, Brno University of Technology, Czech Republic
% Last Revision 2004-08-23

% dwtmode('per');

if nargin<3
    error('Insufficient number of parameters!');
elseif nargin==3
    plot_boolean=0;
elseif ~isnumeric(plot_boolean) | length(plot_boolean)>1
    error('"plot_boolean" must be single integer');
end  %v ostatnich pripadech je plot_boolean jedno cislo

%bohuzel musim preskladat bunky--sloupce do radku
for count=1:length(coefs)
    coefs{count}=coefs{count}';
end

%poskladani koeficientu z bunek do vektoru a rekonstrukce
signal=waverec([coefs{:}],L,wav_name);